import { CommandManager } from '../command/CommandManager';
import { Page } from './Page';
import { LayoutNode } from './base';
import { LayoutManager } from '../layout/LayoutManager';
import { LayoutMapper } from '../layout/LayoutMapper';
import { CursorManager } from '../cursor/CursorManager';
import { EventManager } from '../event/EventManager';
import { DataManager } from '../data/DataManager';
import { InteractionManager } from '../interaction/InteractionManager';
import { DocModeType } from '../constants';
import { CommandPayloadMap, RequiredPayloadCommands, OptionalPayloadCommands } from '../command/types';
import { DocModel } from '../model';
import { DocRuntimeMeta } from '../../sdk';
export interface DocInitOptions {
    mode?: DocModeType;
    model?: DocModel;
    preview?: boolean;
    mainModelKey: ModelKey;
    /** 文档运行时元信息（接口数据 + 业务数据） */
    docRuntimeMeta: DocRuntimeMeta;
    formType: string;
    paramsConfig: Record<string, any>;
    pageSize?: {
        width: number;
        height: number;
    };
    pagePadding?: [number, number, number, number];
    onLayoutChange?: (doc: Doc) => void;
    onSelectionChange?: (doc: Doc) => void;
}
export declare class Doc {
    id: string;
    /** 渲染模式 */
    mode: DocModeType;
    /** 是否是设计器预览模式 */
    preview: boolean;
    model?: DocModel;
    pages: Page[];
    commandManager: CommandManager;
    layoutManager: LayoutManager;
    layoutMapper: LayoutMapper;
    cursorManager: CursorManager;
    eventManager: EventManager;
    dataManager: DataManager;
    interactionManager: InteractionManager;
    pageSize: {
        width: number;
        height: number;
    };
    pagePadding: [number, number, number, number];
    /** 当前表单主模型 key */
    mainModelKey: string;
    /** 当前表单类型 */
    formType: string;
    /** 文档运行时元信息（接口数据 + 业务数据） */
    docRuntimeMeta: DocRuntimeMeta;
    /** 外部的参数配置 */
    paramsConfig: Record<string, any>;
    /** 安全距离-上下 */
    SAFE_DIST_Y: number;
    /** 安全距离-左右 */
    SAFE_DIST_X: number;
    /** 纸张之间的间距 */
    PAGE_GAP: number;
    /** 缩放值 */
    scale: number;
    /** 每页的偏移量 */
    pageOffsets: {
        [k: string]: {
            top: number;
            left: number;
            width: number;
        };
    };
    /** 最大的纸张宽度(带安全距离) */
    pageMaxWidth: number;
    /** UI 变更计数器 */
    private _updateTick;
    private _textRunCount;
    onLayoutChange?: (doc: Doc) => void;
    onSelectionChange?: (doc: Doc) => void;
    constructor(options: DocInitOptions);
    get updateTick(): number;
    get modeLabel(): "" | "设计模式" | "填报模式" | "打印模式";
    getFirstPage(): Page | null;
    getLastPage(): Page | null;
    setModel(model: DocModel): void;
    setMode(modeType: DocModeType): void;
    /** 触发布局计算 */
    layout(): void;
    /** 渲染文档 */
    render(): void;
    /**
     * 执行命令 - 必须提供 payload 的命令
     */
    execute<T extends RequiredPayloadCommands>(name: T, payload: CommandPayloadMap[T]): void;
    /**
     * 执行命令 - payload 可选的命令
     */
    execute<T extends OptionalPayloadCommands>(name: T, payload?: CommandPayloadMap[T]): void;
    undo(): void;
    redo(): void;
    /** 销毁文档 */
    destroy(): void;
    hasPage(page: Page): boolean;
    addPage(page: Page): Page | undefined;
    /** 是否是设计模式 */
    isInEditMode(): boolean;
    /** 是否是填报模式 */
    isInFillMode(): boolean;
    /** 是否是打印模式 */
    isInPrintMode(): boolean;
    bumpUpdateTick(): void;
    increaseTextRunCount(): void;
    /**
     * 获取所有同时存在 widgetMeta 和 valuePath 的实例
     * @returns Wr 实例数组（包含 widgetMeta 和 valuePath 的文本或图片 run）
     */
    getWidgetInstances(): LayoutNode[];
}
